/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using MPLAB(c) Code Configurator

  @Description:
    This header file provides implementations for pin APIs for all pins selected in the GUI.
    Generation Information :
        Product Revision  :  MPLAB(c) Code Configurator - 4.0
        Device            :  PIC16F1827
        Version           :  1.01
    The generated drivers are tested against the following:
        Compiler          :  XC8 1.35
        MPLAB             :  MPLAB X 3.40

    Copyright (c) 2013 - 2015 released Microchip Technology Inc.  All rights reserved.

    Microchip licenses to you the right to use, modify, copy and distribute
    Software only when embedded on a Microchip microcontroller or digital signal
    controller that is integrated into your product or third party product
    (pursuant to the sublicense terms in the accompanying license agreement).

    You should refer to the license agreement accompanying this Software for
    additional information regarding your rights and obligations.

    SOFTWARE AND DOCUMENTATION ARE PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND,
    EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION, ANY WARRANTY OF
    MERCHANTABILITY, TITLE, NON-INFRINGEMENT AND FITNESS FOR A PARTICULAR PURPOSE.
    IN NO EVENT SHALL MICROCHIP OR ITS LICENSORS BE LIABLE OR OBLIGATED UNDER
    CONTRACT, NEGLIGENCE, STRICT LIABILITY, CONTRIBUTION, BREACH OF WARRANTY, OR
    OTHER LEGAL EQUITABLE THEORY ANY DIRECT OR INDIRECT DAMAGES OR EXPENSES
    INCLUDING BUT NOT LIMITED TO ANY INCIDENTAL, SPECIAL, INDIRECT, PUNITIVE OR
    CONSEQUENTIAL DAMAGES, LOST PROFITS OR LOST DATA, COST OF PROCUREMENT OF
    SUBSTITUTE GOODS, TECHNOLOGY, SERVICES, OR ANY CLAIMS BY THIRD PARTIES
    (INCLUDING BUT NOT LIMITED TO ANY DEFENSE THEREOF), OR OTHER SIMILAR COSTS.

*/


#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set channel_l aliases
#define channel_l_TRIS               TRISAbits.TRISA0
#define channel_l_LAT                LATAbits.LATA0
#define channel_l_PORT               PORTAbits.RA0
#define channel_l_ANS                ANSELAbits.ANSA0
#define channel_l_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define channel_l_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define channel_l_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define channel_l_GetValue()           PORTAbits.RA0
#define channel_l_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define channel_l_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define channel_l_SetAnalogMode()  do { ANSELAbits.ANSA0 = 1; } while(0)
#define channel_l_SetDigitalMode() do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set channel_r aliases
#define channel_r_TRIS               TRISAbits.TRISA1
#define channel_r_LAT                LATAbits.LATA1
#define channel_r_PORT               PORTAbits.RA1
#define channel_r_ANS                ANSELAbits.ANSA1
#define channel_r_SetHigh()            do { LATAbits.LATA1 = 1; } while(0)
#define channel_r_SetLow()             do { LATAbits.LATA1 = 0; } while(0)
#define channel_r_Toggle()             do { LATAbits.LATA1 = ~LATAbits.LATA1; } while(0)
#define channel_r_GetValue()           PORTAbits.RA1
#define channel_r_SetDigitalInput()    do { TRISAbits.TRISA1 = 1; } while(0)
#define channel_r_SetDigitalOutput()   do { TRISAbits.TRISA1 = 0; } while(0)
#define channel_r_SetAnalogMode()  do { ANSELAbits.ANSA1 = 1; } while(0)
#define channel_r_SetDigitalMode() do { ANSELAbits.ANSA1 = 0; } while(0)

// get/set LED2 aliases
#define LED2_TRIS               TRISAbits.TRISA6
#define LED2_LAT                LATAbits.LATA6
#define LED2_PORT               PORTAbits.RA6
#define LED2_SetHigh()            do { LATAbits.LATA6 = 1; } while(0)
#define LED2_SetLow()             do { LATAbits.LATA6 = 0; } while(0)
#define LED2_Toggle()             do { LATAbits.LATA6 = ~LATAbits.LATA6; } while(0)
#define LED2_GetValue()           PORTAbits.RA6
#define LED2_SetDigitalInput()    do { TRISAbits.TRISA6 = 1; } while(0)
#define LED2_SetDigitalOutput()   do { TRISAbits.TRISA6 = 0; } while(0)

// get/set LED1 aliases
#define LED1_TRIS               TRISAbits.TRISA7
#define LED1_LAT                LATAbits.LATA7
#define LED1_PORT               PORTAbits.RA7
#define LED1_SetHigh()            do { LATAbits.LATA7 = 1; } while(0)
#define LED1_SetLow()             do { LATAbits.LATA7 = 0; } while(0)
#define LED1_Toggle()             do { LATAbits.LATA7 = ~LATAbits.LATA7; } while(0)
#define LED1_GetValue()           PORTAbits.RA7
#define LED1_SetDigitalInput()    do { TRISAbits.TRISA7 = 1; } while(0)
#define LED1_SetDigitalOutput()   do { TRISAbits.TRISA7 = 0; } while(0)

// get/set LED_L_LO aliases
#define LED_L_LO_TRIS               TRISBbits.TRISB0
#define LED_L_LO_LAT                LATBbits.LATB0
#define LED_L_LO_PORT               PORTBbits.RB0
#define LED_L_LO_WPU                WPUBbits.WPUB0
#define LED_L_LO_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define LED_L_LO_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define LED_L_LO_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define LED_L_LO_GetValue()           PORTBbits.RB0
#define LED_L_LO_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define LED_L_LO_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define LED_L_LO_SetPullup()      do { WPUBbits.WPUB0 = 1; } while(0)
#define LED_L_LO_ResetPullup()    do { WPUBbits.WPUB0 = 0; } while(0)

// get/set LED_R_LO aliases
#define LED_R_LO_TRIS               TRISBbits.TRISB1
#define LED_R_LO_LAT                LATBbits.LATB1
#define LED_R_LO_PORT               PORTBbits.RB1
#define LED_R_LO_WPU                WPUBbits.WPUB1
#define LED_R_LO_ANS                ANSELBbits.ANSB1
#define LED_R_LO_SetHigh()            do { LATBbits.LATB1 = 1; } while(0)
#define LED_R_LO_SetLow()             do { LATBbits.LATB1 = 0; } while(0)
#define LED_R_LO_Toggle()             do { LATBbits.LATB1 = ~LATBbits.LATB1; } while(0)
#define LED_R_LO_GetValue()           PORTBbits.RB1
#define LED_R_LO_SetDigitalInput()    do { TRISBbits.TRISB1 = 1; } while(0)
#define LED_R_LO_SetDigitalOutput()   do { TRISBbits.TRISB1 = 0; } while(0)
#define LED_R_LO_SetPullup()      do { WPUBbits.WPUB1 = 1; } while(0)
#define LED_R_LO_ResetPullup()    do { WPUBbits.WPUB1 = 0; } while(0)
#define LED_R_LO_SetAnalogMode()  do { ANSELBbits.ANSB1 = 1; } while(0)
#define LED_R_LO_SetDigitalMode() do { ANSELBbits.ANSB1 = 0; } while(0)

// get/set LED_L_HI aliases
#define LED_L_HI_TRIS               TRISBbits.TRISB2
#define LED_L_HI_LAT                LATBbits.LATB2
#define LED_L_HI_PORT               PORTBbits.RB2
#define LED_L_HI_WPU                WPUBbits.WPUB2
#define LED_L_HI_ANS                ANSELBbits.ANSB2
#define LED_L_HI_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define LED_L_HI_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define LED_L_HI_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define LED_L_HI_GetValue()           PORTBbits.RB2
#define LED_L_HI_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define LED_L_HI_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define LED_L_HI_SetPullup()      do { WPUBbits.WPUB2 = 1; } while(0)
#define LED_L_HI_ResetPullup()    do { WPUBbits.WPUB2 = 0; } while(0)
#define LED_L_HI_SetAnalogMode()  do { ANSELBbits.ANSB2 = 1; } while(0)
#define LED_L_HI_SetDigitalMode() do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set LED_R_HI aliases
#define LED_R_HI_TRIS               TRISBbits.TRISB3
#define LED_R_HI_LAT                LATBbits.LATB3
#define LED_R_HI_PORT               PORTBbits.RB3
#define LED_R_HI_WPU                WPUBbits.WPUB3
#define LED_R_HI_ANS                ANSELBbits.ANSB3
#define LED_R_HI_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define LED_R_HI_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define LED_R_HI_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define LED_R_HI_GetValue()           PORTBbits.RB3
#define LED_R_HI_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define LED_R_HI_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define LED_R_HI_SetPullup()      do { WPUBbits.WPUB3 = 1; } while(0)
#define LED_R_HI_ResetPullup()    do { WPUBbits.WPUB3 = 0; } while(0)
#define LED_R_HI_SetAnalogMode()  do { ANSELBbits.ANSB3 = 1; } while(0)
#define LED_R_HI_SetDigitalMode() do { ANSELBbits.ANSB3 = 0; } while(0)

// get/set LED6 aliases
#define LED6_TRIS               TRISBbits.TRISB4
#define LED6_LAT                LATBbits.LATB4
#define LED6_PORT               PORTBbits.RB4
#define LED6_WPU                WPUBbits.WPUB4
#define LED6_ANS                ANSELBbits.ANSB4
#define LED6_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define LED6_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define LED6_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define LED6_GetValue()           PORTBbits.RB4
#define LED6_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define LED6_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define LED6_SetPullup()      do { WPUBbits.WPUB4 = 1; } while(0)
#define LED6_ResetPullup()    do { WPUBbits.WPUB4 = 0; } while(0)
#define LED6_SetAnalogMode()  do { ANSELBbits.ANSB4 = 1; } while(0)
#define LED6_SetDigitalMode() do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set LED5 aliases
#define LED5_TRIS               TRISBbits.TRISB5
#define LED5_LAT                LATBbits.LATB5
#define LED5_PORT               PORTBbits.RB5
#define LED5_WPU                WPUBbits.WPUB5
#define LED5_ANS                ANSELBbits.ANSB5
#define LED5_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define LED5_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define LED5_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define LED5_GetValue()           PORTBbits.RB5
#define LED5_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define LED5_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define LED5_SetPullup()      do { WPUBbits.WPUB5 = 1; } while(0)
#define LED5_ResetPullup()    do { WPUBbits.WPUB5 = 0; } while(0)
#define LED5_SetAnalogMode()  do { ANSELBbits.ANSB5 = 1; } while(0)
#define LED5_SetDigitalMode() do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set LED4 aliases
#define LED4_TRIS               TRISBbits.TRISB6
#define LED4_LAT                LATBbits.LATB6
#define LED4_PORT               PORTBbits.RB6
#define LED4_WPU                WPUBbits.WPUB6
#define LED4_ANS                ANSELBbits.ANSB6
#define LED4_SetHigh()            do { LATBbits.LATB6 = 1; } while(0)
#define LED4_SetLow()             do { LATBbits.LATB6 = 0; } while(0)
#define LED4_Toggle()             do { LATBbits.LATB6 = ~LATBbits.LATB6; } while(0)
#define LED4_GetValue()           PORTBbits.RB6
#define LED4_SetDigitalInput()    do { TRISBbits.TRISB6 = 1; } while(0)
#define LED4_SetDigitalOutput()   do { TRISBbits.TRISB6 = 0; } while(0)
#define LED4_SetPullup()      do { WPUBbits.WPUB6 = 1; } while(0)
#define LED4_ResetPullup()    do { WPUBbits.WPUB6 = 0; } while(0)
#define LED4_SetAnalogMode()  do { ANSELBbits.ANSB6 = 1; } while(0)
#define LED4_SetDigitalMode() do { ANSELBbits.ANSB6 = 0; } while(0)

// get/set LED3 aliases
#define LED3_TRIS               TRISBbits.TRISB7
#define LED3_LAT                LATBbits.LATB7
#define LED3_PORT               PORTBbits.RB7
#define LED3_WPU                WPUBbits.WPUB7
#define LED3_ANS                ANSELBbits.ANSB7
#define LED3_SetHigh()            do { LATBbits.LATB7 = 1; } while(0)
#define LED3_SetLow()             do { LATBbits.LATB7 = 0; } while(0)
#define LED3_Toggle()             do { LATBbits.LATB7 = ~LATBbits.LATB7; } while(0)
#define LED3_GetValue()           PORTBbits.RB7
#define LED3_SetDigitalInput()    do { TRISBbits.TRISB7 = 1; } while(0)
#define LED3_SetDigitalOutput()   do { TRISBbits.TRISB7 = 0; } while(0)
#define LED3_SetPullup()      do { WPUBbits.WPUB7 = 1; } while(0)
#define LED3_ResetPullup()    do { WPUBbits.WPUB7 = 0; } while(0)
#define LED3_SetAnalogMode()  do { ANSELBbits.ANSB7 = 1; } while(0)
#define LED3_SetDigitalMode() do { ANSELBbits.ANSB7 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/